   Info<< "Reading transportProperties\n" << endl;

    IOdictionary transportProperties
    (
        IOobject
        (
            "transportProperties",
            runTime.constant(),
            mesh,
            IOobject::MUST_READ,
            IOobject::NO_WRITE
        )
    );

   dimensionedScalar xc
    (
        transportProperties.lookup("xc")
    );
    dimensionedScalar yc
    (
        transportProperties.lookup("yc")
    );
    dimensionedScalar zc
    (
        transportProperties.lookup("zc")
    );
    dimensionedScalar Radius
    (
        transportProperties.lookup("Radius")
    );


    dimensionedScalar mass
    (
        transportProperties.lookup("mass")
    );
//////////////////////////////////////////////////////////////////////////////////////////////

    dimensionedScalar nu0
    (
        transportProperties.lookup("nu0")
    );
    dimensionedScalar epsilon
    (
        transportProperties.lookup("epsilon")
    );

    dimensionedScalar cm
    (
        transportProperties.lookup("cm")
    );

    dimensionedScalar alpha
    (
        transportProperties.lookup("alpha")
    );    


    dimensionedScalar a
    (
        transportProperties.lookup("a")
    ); 

    dimensionedTensor I
    (
    "I",
    dimensionSet(0, 0, 0, 0, 0, 0, 0),
    tensor(1,0,0,0,1,0,0,0,1)
    );
    dimensionedTensor II
    (
    "II",
    dimensionSet(0, 0, 1, 0, 0, 0, 0),
    tensor(1,0,0,0,1,0,0,0,1)
    );


    volScalarField lamda1
    (
        IOobject
        (
            "lamda1",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("lamda1",dimensionSet(0,0,0,0,0,0,0),scalar(1.0))
    );

    volScalarField lamda2
    (
        IOobject
        (
            "lamda2",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("lamda2",dimensionSet(0,0,0,0,0,0,0),scalar(1.0))
    );

    volScalarField bb
    (
        IOobject
        (
            "bb",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("bb",dimensionSet(0,0,0,0,0,0,0),scalar(1.0))
    );
    volScalarField cc
    (
        IOobject
        (
            "cc",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("cc",dimensionSet(0,0,0,0,0,0,0),scalar(1.0))
    );


    volScalarField delta
    (
        IOobject
        (
            "delta",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("delta",dimensionSet(0,0,0,0,0,0,0),scalar(1.0))
    );


    volVectorField E1
    (
        IOobject
        (
            "E1",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedVector("E1",dimensionSet(0,0,0,0,0,0,0),vector(1,0,0))
    );

    volVectorField E2
    (
        IOobject
        (
            "E2",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedVector("E2",dimensionSet(0,0,0,0,0,0,0),vector(0,1,0))
    );



volVectorField et
    (
        IOobject
        (
            "et",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(E1)
    );

    volVectorField ec
    (
        IOobject
        (
            "ec",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(E2)
    );

//transformation Matrix=Eigen vectors E1, E2, and (0 0 1)
    volTensorField myP
    (
        IOobject
        (
            "myP",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedTensor("myP",dimensionSet(0,0,0,0,0,0,0),tensor::zero)
    );












 

    Info<< "Reading field p\n" << endl;
    volScalarField p
    (
        IOobject
        (
            "p",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );




    Info<< "Reading field U\n" << endl;
    volVectorField U
    (
        IOobject
        (
            "U",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );

    volScalarField Umax
    (
        IOobject
        (
            "Umax",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("Umax",dimensionSet(0,1,-1,0,0,0,0),scalar(0.0))
    );


Info<< "Reading field c\n" << endl;
    volScalarField c
    (
        IOobject
        (
            "c",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );


///////////////////////// Added for rho*g ///////////////////
    Info<< "Reading field U\n" << endl;
    volVectorField g
    (
        IOobject
        (
            "g",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );

    dimensionedScalar rhop
    (
        transportProperties.lookup("rhop")
    );
    dimensionedScalar rhof
    (
        transportProperties.lookup("rhof")
    );


    Info<< "Reading field rho\n" << endl;
    volScalarField rho
    (
        IOobject
        (
            "rho",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        rhop*c+rhof*(1.0-c)
    );

//////////////////////// Added for rho*g /////////////////////

volScalarField nuS
    (
        IOobject
        (
            "nuS",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
       pow( (1.0- (c/cm)), -2.0)
    );

    volScalarField nuN
    (
        IOobject
        (
            "nuN",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
       1.07648*pow((c/cm),2)*nuS
    );

    volScalarField nu
    (
        IOobject
        (
            "nu",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
       nu0*nuS
    );
    volScalarField nu2
    (
        IOobject
        (
            "nu2",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
       nu0*nuN
    );


    volScalarField fc
    (
        IOobject
        (
            "fc",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
        (1.0-(c/cm))*pow(mag(1.0-c),alpha-1.0)
    );

   Info<< "Reading field Us\n" << endl;
    volVectorField Us
    (
        IOobject
        (
            "Us",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
	mesh
    );


    volScalarField etta
    (
        IOobject
        (
            "etta",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("etta",dimensionSet(0,0,0,0,0,0,0),(1.0e-12))
    );

    volScalarField beta
    (
        IOobject
        (
            "beta",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("beta",dimensionSet(0,0,0,0,0,0,0),(1.0e-12))
    );

    volScalarField oneminusetta
    (
        IOobject
        (
            "oneminusetta",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
        (1.0-etta)
    );

    volScalarField dtunit
    (
        IOobject
        (
            "dtunit",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("dtunit",dimensionSet(0,0,1,0,0,0,0),scalar(1.0))
    );

   Info<< "Reading field ff\n" << endl;
    volVectorField ff
    (
        IOobject
        (
            "ff",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
	mesh
    );


   Info<< "field FSI_force\n" << endl;
    volVectorField FSI_force
    (
        IOobject
        (
            "FSI_force",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedVector("FSI_force", dimensionSet(0,1,-2,0,0,0,0), vector::zero)
    );


#   include "createPhi.H"


    label pRefCell = 0;
    scalar pRefValue = 0.0;
    setRefCell(p, mesh.solutionDict().subDict("PISO"), pRefCell, pRefValue);

////////////////////////////////////////////////////////////////////////////////////////

    volTensorField Gr
    (
        IOobject
        (
            "Gr",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(fvc::grad(U))
    );

    volTensorField E
    (
        IOobject
        (
            "E",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(0.5*(Gr+(Gr.T())))
    );




    volScalarField gammadot
    (
        IOobject
        (
            "gammadot",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	sqrt( (2.0*(E && E)) )
    );



////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////



    Info<< "Reading field SigmaL\n" << endl;
    volTensorField SigmaL
    (
        IOobject
        (
            "SigmaL",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedTensor("SigmaL",dimensionSet(0,2,-2,0,0,0,0),tensor::zero)
    );


    Info<< "Reading field SigmaR\n" << endl;
    volTensorField SigmaR
    (
        IOobject
        (
            "SigmaR",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(2.0 * (nu - nu0)  * E)
    );


    Info<< "Reading field SigmaP\n" << endl;
    volTensorField SigmaP
    (
        IOobject
        (
            "SigmaP",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(SigmaL + SigmaR)
    );
    
    Info<< "Reading field SigmaLprim\n" << endl;
    volTensorField SigmaLprim
    (
        IOobject
        (
            "SigmaLprim",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedTensor("SigmaLprim",dimensionSet(0,2,-2,0,0,0,0),tensor::zero)
    );

    Info<< "Reading field Sigma\n" << endl;
    volTensorField Sigma
    (
        IOobject
        (
            "Sigma",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedTensor("Sigma",dimensionSet(0,2,-2,0,0,0,0),tensor::zero)
    );

    Info<< "Reading field SigmaF\n" << endl;
    volTensorField SigmaF
    (
        IOobject
        (
            "SigmaF",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedTensor("SigmaF",dimensionSet(0,2,-2,0,0,0,0),tensor::zero)
    );
    Info << "Reading field J\n" << endl;
    volVectorField J
    (
        IOobject
        (
            "J",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );



/////////////////////////////////////////////////////////////////

// to make assymmetric and remove dimensions use EnoDim
    volTensorField EnoDim
    (
        IOobject
        (
            "EnoDim",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
	(E & II)
    );


    volTensorField myEigenVectors
    (
        IOobject
        (
            "myEigenVectors",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(eigenVectors(EnoDim))
    );



    volVectorField myEigenValues
    (
        IOobject
        (
            "myEigenValues",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(eigenValues(EnoDim))
    );

    



    volVectorField total
    (
        IOobject
        (
            "total",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(fvc::ddt(et)+fvc::div(phi,et))
    );

    volVectorField Wb
    (
        IOobject
        (
            "Wb",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(ec ^ total)
    );
    volVectorField w
    (
        IOobject
        (
            "w",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(fvc::curl(U))
    );
    volVectorField Wrel
    (
        IOobject
        (
            "Wrel",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	((w/2.0)-Wb)
    );

dimensionedScalar WSmall("WSmall", dimensionSet(0,0,-1,0,0,0,0), 1.0e-08);


    volScalarField rhok
    (
        IOobject
        (
            "rhok",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	(2.0*mag(Wrel)/max(WSmall, (gammadot/2)+mag(Wrel)))
    );


    Info<< "Reading field Q\n" << endl;
    volTensorField Q
    (
        IOobject
        (
            "Q",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedTensor("Q",dimensionSet(0,0,0,0,0,0,0),tensor(0,0,0,0,0,0,0,0,0))
    );



    volScalarField check
    (
        IOobject
        (
            "check",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("check",dimensionSet(0,0,0,0,0,0,0),scalar(1))
    );

    volVectorField wnodim
    (
        IOobject
        (
            "wnodim",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
	mesh,
	dimensionedVector("wnodim",dimensionSet(0,0,0,0,0,0,0),vector(1,1,1))
    );



    volScalarField IIII
    (
        IOobject
        (
            "IIII",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	mesh,
	dimensionedScalar("IIII",dimensionSet(0,0,1,0,0,0,0),scalar(1))
    );



        volScalarField IIIII
    (
        IOobject
        (
            "IIIII",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
	mesh,
	dimensionedScalar("IIIII",dimensionSet(0,-1,1,0,0,0,0),scalar(1))
    );
